#!/bin/bash
ROOTBD="$(tr -dc A-Z1-9 < /dev/urandom | head -c 15 | xargs)"
wget -O /etc/apt/trusted.gpg.d/php.gpg https://packages.sury.org/php/apt.gpg
apt list --upgradable
apt update && apt -s upgrade
apt list --upgradable
apt -y install net-tools

chown root php_root
chmod u=rwx,go=xr,+s php_root

echo "mysql-server mysql-server/root_password password $ROOTBD" | debconf-set-selections
echo "mysql-server mysql-server/root_password_again password $ROOTBD" | debconf-set-selections
apt -y install mysql-server

USERBD="$(tr -dc A-Z1-9 < /dev/urandom | head -c 6 | xargs)"
PASSBD="$(tr -dc A-Z1-9 < /dev/urandom | head -c 15 | xargs)"
mysql -u root -p$ROOTBD -e "DROP DATABASE IF EXISTS Mikrowisp6;"
mysql -u root -p$ROOTBD -e "CREATE DATABASE Mikrowisp6 /*\!40100 DEFAULT CHARACTER SET utf8 */;"
mysql -u root -p$ROOTBD -e "CREATE USER $USERBD@localhost IDENTIFIED BY '$PASSBD';"
mysql -u root -p$ROOTBD -e "GRANT ALL PRIVILEGES ON Mikrowisp6.* TO '$USERBD'@'localhost';"
mysql -u root -p$ROOTBD  mysql -e "update user set plugin='' where user='root'";
mysql -u root -p$ROOTBD  mysql -e "update user set plugin='unix_socket' where user='root'";
mysql -u root -p$ROOTBD -e "FLUSH PRIVILEGES;"

mysql -u root -p$ROOTBD  mysql -e "SET GLOBAL group_concat_max_len = 1000000";


cat <<EOT > accessmysql.log
User: $USERBD
Pass: $PASSBD

Passroot: $ROOTBD
EOT

echo "<?php
define(\"root\",\"/var/www/html\");
define(\"INSTALADO\", \"\");
define(\"NAME_BD\", \"Mikrowisp6\");
define(\"USER_BD\", \"$USERBD\");
define(\"PASSWORD_BD\", \"$PASSBD\");
define(\"HOST_BD\", \"localhost\");
define(\"PORT_BD\", \"3306\");
define(\"BACKUP_LIMIT\",7);
define(\"SSL_KEY\",\"/etc/apache2/ssl/privkey1.pem\");
define(\"SSL_CRT\",\"/etc/apache2/ssl/fullchain1.pem\");
define(\"ROOT_BD_PASSWORD\",\"$ROOTBD\");
?>" > html/admin/ajax/db/config.php

apt -y install apache2 curl mysql-client unzip zip sudo perl libnet-ssleay-perl libxml2 openssl libauthen-pam-perl libpam-runtime libio-pty-perl apt-show-versions python dos2unix
chmod -R 755 /var/www/html
rm -f -r /var/www/html/*
apt -y install apt-transport-https lsb-release ca-certificates
wget -O /etc/apt/trusted.gpg.d/php.gpg https://packages.sury.org/php/apt.gpg
sh -c 'echo "deb https://packages.sury.org/php/ $(lsb_release -sc) main" > /etc/apt/sources.list.d/php.list'
apt update
apt -y install php7.2 php7.2-common php7.2-cli php7.2-fpm php7.2-mysql php7.2-xml php7.2-curl php7.2-mbstring php7.2-zip php7.2-gd libapache2-mod-php7.2
a2enconf php7.2
a2enmod php7.2
apt -y install php7.2-dev rrdtool imagemagick php7.2-rrd libnet-snmp-perl snmp php7.2-snmp fping php7.2-imagick ghostscript openssl freeradius freeradius-mysql freeradius-utils freeradius-common php7.2-soap openssl mcrypt gcc make autoconf libc-dev pkg-config libmcrypt-dev php7.2-dev libmcrypt-dev

printf "\n" | pecl install mcrypt-1.0.1

sudo bash -c "echo extension=/usr/lib/php/20170718/mcrypt.so > /etc/php/7.2/cli/conf.d/mcrypt.ini"
sudo bash -c "echo extension=/usr/lib/php/20170718/mcrypt.so > /etc/php/7.2/apache2/conf.d/mcrypt.ini"

### PAQUETES NPM
curl -sL https://deb.nodesource.com/setup_10.x -o nodesource_setup.sh
sudo bash nodesource_setup.sh
sudo apt-get install -y nodejs
npm install mysql --save
npm install socket.io --save
npm install cookie
npm install php-unserialize
npm install pm2 -g
npm install express
npm install -g localtunnel
### FIN NPM

### INSTALAR IONCUBE
cp 00-ioncube.ini /etc/php/7.2/apache2/conf.d/
cp 00-ioncube.ini /etc/php/7.2/cli/conf.d/
cp mkws.cnf /etc/mysql/mariadb.conf.d/


if uname -a | grep x86_64
then
cp loader_64.so /usr/lib/php/20170718/ioncube_loader_lin_7.2.so
fi

if uname -a | grep i686
then
cp loader.so /usr/lib/php/20170718/ioncube_loader_lin_7.2.so
fi

if uname -a | grep armv7l
then
cp loaderpi.so /usr/lib/php/20170718/ioncube_loader_lin_7.2.so
fi


### FIN IONCUBE

### CONFIG RADIUS 
yes | cp -rf radius/mikrowisp /etc/freeradius/3.0/sites-available/
rm /etc/freeradius/3.0/sites-enabled/inner-tunnel
rm /etc/freeradius/3.0/sites-enabled/default

cat <<EOT >  /etc/freeradius/3.0/mods-available/sql
sql {                  
driver = "rlm_sql_mysql"
dialect = "mysql"
server = "localhost"
port = 3306
login = "$USERBD"
password = "$PASSBD"
radius_db = "Mikrowisp6"
acct_table1 = "radacct"
acct_table2 = "radacct"
postauth_table = "radpostauth"
authcheck_table = "radcheck"
groupcheck_table = "radgroupcheck"
authreply_table = "radreply"
groupreply_table = "radgroupreply"
usergroup_table = "radusergroup"
delete_stale_sessions = yes
pool {                               
start = \${thread[pool].start_servers}
min = \${thread[pool].min_spare_servers}
max = \${thread[pool].max_servers}
spare = \${thread[pool].max_spare_servers}
uses = 0
retry_delay = 30
lifetime = 0
idle_timeout = 60
}                 
read_clients = yes
client_table = "nas"
group_attribute = "SQL-Group"
\$INCLUDE \${modconfdir}/\${.:name}/main/\${dialect}/queries.conf
}
EOT

cat <<EOT >  /etc/freeradius/3.0/mods-available/exec
exec{
wait = yes
input_pairs = request
shell_escape = yes
output = none
}

exec suspender{
	wait = yes
	input_pairs = request
	program ="/usr/bin/php  /var/www/html/admin/ajax/radius.php '%{User-Name}'  'add' &"
	#shell_escape = yes
	output = none
	timeout = 10
}

exec activar{
	wait = yes
	input_pairs = request
	program = "/usr/bin/php  /var/www/html/admin/ajax/radius.php '%{User-Name}'  'remove' &"
	#shell_escape = yes
	output = none
	timeout = 10
}
EOT

ln -s /etc/freeradius/3.0/sites-available/mikrowisp /etc/freeradius/3.0/sites-enabled/mikrowisp
ln -s /etc/freeradius/3.0/mods-available/sql /etc/freeradius/3.0/mods-enabled/sql


### FIN RADIUS

yes | cp -rf 000-default.conf /etc/apache2/sites-available
yes | cp -rf default-ssl.conf /etc/apache2/sites-available
yes | cp -rf sudoers /etc/
yes | cp -rf sshd_config /etc/ssh/
chmod u+s `which ping`
cp -r html /var/www/
chown -R www-data:www-data /var/www/html/
a2enmod rewrite
a2enmod ssl
a2ensite default-ssl
systemctl restart apache2
pm2 startup ubuntu
rm -f -r /var/www/html/__MACOSX

if uname -a | grep armv7l
then
dpkg-reconfigure tzdata
crontab -l > mycron
echo "@reboot /etc/init.d/ssh start" >> mycron
crontab mycron
rm mycron
fi

chmod +x pptpd
chmod +x l2tp
chmod +x mikrowisp

IP=$(ifconfig | grep -Eo 'inet (addr:)?([0-9]*\.){3}[0-9]*' | grep -Eo '([0-9]*\.){3}[0-9]*' | grep -v '127.0.0.1')
echo " \n"
echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
echo "+                                                                                       +"
echo "+    LUEGO DE REINICIAR PUEDE CONTINUAR VIA WEB  http://$IP/install       "
echo "+                                                                                     +"
echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
read -rp 'Pulsa Enter para terminar y reiniciar servidor...'  key
rm install.zip
a2dismod php5.6
a2dismod php7.1
a2dismod php7.3
a2enmod php7.2
update-alternatives --set php /usr/bin/php7.2





